import javax.swing.*;
import java.awt.event.*;
import java.io.*;


public class BrowsePairing implements ActionListener {
    private JTextField textBox;
    private JButton browseButton;
    private DynamicFileFilter filter;

    public BrowsePairing(JTextField textBox, JButton browseButton, DynamicFileFilter filter)
    {
        this.textBox = textBox;
        this.browseButton = browseButton;
        this.filter = filter;

        browseButton.addActionListener(this);
    }

    public void actionPerformed(ActionEvent e)
    {
        JFileChooser fc = new JFileChooser();
        fc.addChoosableFileFilter( filter );
        int ret = fc.showOpenDialog(new FileChooserImpl());
        if( ret == JFileChooser.APPROVE_OPTION )
        {
            File f = fc.getSelectedFile();
            String fileName = f.getAbsolutePath();
            textBox.setText(fileName);
        }
    }
}
