import java.io.File;
import javax.swing.*;
import java.util.ArrayList;
import javax.swing.filechooser.*;

public class DynamicFileFilter extends FileFilter {

    private ArrayList<String> m_allowedExtensions;
    private String m_description;

    public DynamicFileFilter(String description)
    {
        m_description = description;
        m_allowedExtensions = new ArrayList<String>();
    }

    public void addAllowedExtension(String extension)
    {
        m_allowedExtensions.add(extension.toLowerCase());
    }

    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
    
    public boolean accept(File f) {
        if(f == null) return false;
        
        if(f.isDirectory())
            return true;
            
        String extension = getExtension(f);
        if( extension != null && m_allowedExtensions.contains(extension) )
            return true;
            
        return false;
    }
    
    public String getDescription() {
        return m_description;
    }
}
