import java.io.*;
import java.nio.channels.*;

public class MapSwapper
{   
    private String mapFile;
    private String blizzFile;;
    boolean m_swapped = false;

    private MapSwapper()
    {
    }
    
    public void setMapFile(String s)
    {
        mapFile = s;
    }

    public void setBlizzardFile(String s)
    {
        blizzFile = s;
    }

    public boolean swapped()
    {
        return m_swapped;
    }

    private void copyFile(File from, File to)
    {
        try
        {
        FileChannel inChannel = new FileInputStream(from).getChannel();
        FileChannel outChannel = new FileOutputStream(to).getChannel();
        inChannel.transferTo(0, inChannel.size(), outChannel);
        } catch(Exception e)
        {}
    }
    
    public boolean swap()
    {
        File f = new File(blizzFile);
        if(!f.exists())
            return false;

        f.renameTo(new File(f.getAbsolutePath() + ".bak") );


        f = new File(mapFile);
        if(!f.exists())
            return false;

        copyFile( f, new File(blizzFile) );

        m_swapped = true;
        return true;
    }
    
    public boolean restore()
    {
        File f = new File(blizzFile);
        if(!f.delete())
            return false;

        f = new File(blizzFile + ".bak" );
        f.renameTo( new File(blizzFile) );
        m_swapped = false;
        return true;
    }
    

    private static MapSwapper m_swapper;
    
    public static MapSwapper getSingleton()
    {
        if( m_swapper == null)
            m_swapper = new MapSwapper();
            
        return m_swapper;
    }
}