public enum OperatingSystem
{
    WINDOWS,
    MACOSX,
    MAX_SUPPORTED_OS;
    
    private static String m_appDataPathCache = null;
    private static OperatingSystem m_osCache = null;
    
    private static boolean m_isWindowsXP = false;
    
    public static OperatingSystem GetCurrentOS()
    {
        if( m_osCache != null )
            return m_osCache;
            
        String osName = System.getProperty("os.name");
        if( osName.toLowerCase().contains("windows xp") )
        {
            m_isWindowsXP = true;
        }
        
        if( osName.toLowerCase().contains("windows") )
            m_osCache = WINDOWS;
        else if( osName.toLowerCase().contains("mac os x") )
            m_osCache = MACOSX;
        
        if( m_osCache != null )
            return m_osCache;
            
        System.out.println("Unrecognized operating system!");
        System.exit(-1);
        return WINDOWS;
    }

    public static String GetSC2MapCacheFolder()
    {
        switch( GetCurrentOS() )
        {
            case WINDOWS:
            {
                if( !m_isWindowsXP )
                    return "C:\\ProgramData\\Blizzard Entertainment\\Battle.net\\Cache\\";
                else
                    return "C:\\documents and settings\\all users\\application data\\blizzard entertainment\\battle.net\\cache\\";

            }
            case MACOSX:
            {
                return "/Users/Shared/Blizzard/Battle.net/Cache/";
            }
        }

        return "";
    }
    
    public static boolean is64BitArchitecture()
    {
        return (System.getProperty("os.arch").indexOf("64") != -1 );
    }
    
}
