import java.io.*;

public class RegQuery {

  private static final String REGQUERY_UTIL = "reg query ";
  private static final String REGSTR_TOKEN = "REG_SZ";
  private static final String REGDWORD_TOKEN = "REG_DWORD";
     
     private static final String APP_DATA_CMD = REGQUERY_UTIL +
    "\"HKCU\\Software\\Microsoft\\Windows\\CurrentVersion\\" 
     + "Explorer\\Shell Folders\" /v \"Local AppData\"";
 
  private static final String STARCRAFT_INSTALL_CMD64 = REGQUERY_UTIL +
   "\"HKLM\\SOFTWARE\\Wow6432Node\\Blizzard Entertainment\\Starcraft II\"" 
     + " /v InstallPath";
     
  private static final String STARCRAFT_INSTALL_CMD = REGQUERY_UTIL +
   "\"HKLM\\SOFTWARE\\Blizzard Entertainment\\Starcraft II\"" 
     + " /v InstallPath";
  
  public static String getCurrentUserLocalAppDataPath() {
    try {
      Process process = Runtime.getRuntime().exec(APP_DATA_CMD);
      StreamReader reader = new StreamReader(process.getInputStream());

      reader.start();
      process.waitFor();
      reader.join();

      String result = reader.getResult();
      int p = result.indexOf(REGSTR_TOKEN);

      if (p == -1)
         return null;

      return result.substring(p + REGSTR_TOKEN.length()).trim();
    }
    catch (Exception e) {
      return null;
    }
  }

  public static String getStarcraftInstallPath() {
    try {
      boolean x64 = OperatingSystem.is64BitArchitecture();
      String s = (x64) ? STARCRAFT_INSTALL_CMD64 : STARCRAFT_INSTALL_CMD;
      Process process = Runtime.getRuntime().exec(s);
      StreamReader reader = new StreamReader(process.getInputStream());

      reader.start();
      process.waitFor();
      reader.join();

      String result = reader.getResult();
      int p = result.indexOf(REGSTR_TOKEN);

      if (p == -1)
         return null;

      return result.substring(p + REGSTR_TOKEN.length()).trim();
    }
    catch (Exception e) {
      return null;
    }
  }

  static class StreamReader extends Thread {
    private InputStream is;
    private StringWriter sw;

    StreamReader(InputStream is) {
      this.is = is;
      sw = new StringWriter();
    }

    public void run() {
      try {
        int c;
        while ((c = is.read()) != -1)
          sw.write(c);
        }
        catch (IOException e) { ; }
      }

    String getResult() {
      return sw.toString();
    }
}
}