
import java.util.prefs.Preferences;
public class Settings {
    private static final int m_settingsVersion = 1;

    public static void checkSettings()
    {
        if( m_preferences.getInt("SettingsVersion", 0) != m_settingsVersion )
        {
            // Reset all settings w/ version update.
            resetSettings();

            m_preferences.putInt("SettingsVersion", m_settingsVersion );
        }
    }

    public static void resetSettings()
    {
        try
        {
            m_preferences.clear();
        } catch(Exception e) {}
    }

    private static Preferences m_preferences = Preferences.userRoot().node("MapCraft");

    private static String getDefaultMapFile()
    { // 8-player Extinction
        return "1f/43/1f4315e4e3c02a0f72e578c7288ff1b8910c2b714fb381d0d7aa3f068de2ce6c.s2ma";
    }

    public static void setMultiplayerMapSwapFile(String map)
    {
        m_preferences.put("MultiplayerMapSwapFile", map);
    }

    public static String getMultiplayerMapSwapFile()
    {
        return m_preferences.get("MultiplayerMapSwapFile", OperatingSystem.GetSC2MapCacheFolder() + getDefaultMapFile());
    }

    public static void setStarcraftApp(String app)
    {
        m_preferences.put("StarcraftApp", app);
    }

    private static String getDefaultStarcraftApp()
    {
        if( OperatingSystem.GetCurrentOS() == OperatingSystem.MACOSX )
        {
            return "/Applications/Starcraft II Beta/Starcraft II.app";
        }
        else
            return RegQuery.getStarcraftInstallPath() + "\\Starcraft II.exe";
    }

    public static String getStarcraftApp()
    {
        return m_preferences.get("StarcraftApp", getDefaultStarcraftApp());
    }
}
